﻿using MahApps.Metro.Controls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Plane.FormationCreator
{
    /// <summary>
    /// PlaneMessageBox.xaml 的交互逻辑
    /// </summary>
    public partial class PlaneMessageBox : MetroWindow
    {
        private static PlaneMessageBox staticInstance = null;
        public static bool OnShow(string planmeMessageBox, string caption, ref string content)
        {
            bool ret = false;
            
            if (staticInstance == null)
            {
                staticInstance = new PlaneMessageBox();
            }
           
            staticInstance.messageBoxText.Text = planmeMessageBox;
            staticInstance.Title = caption;
            staticInstance.textbox.Text = content;
            staticInstance.ShowDialog();
            ret = staticInstance.DialogResult == true;
            content = staticInstance.textbox.Text;
            staticInstance.Close();
            staticInstance = null;
            return ret;
        } 

        public PlaneMessageBox()
        {
            InitializeComponent();
        }

        private void ButtonOK_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = true;
        }

        private void ButtonCancel_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = false;
        }

        private void Box_OnKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                //todo 焦点问题没解决前不放出
                DialogResult = true;
            }
        }
    }
}
